unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdAntiFreezeBase, IdAntiFreeze;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ComboBox1: TComboBox;
    IdAntiFreeze1: TIdAntiFreeze;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    procedure getadds(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses Wininet, idHttp;

function SystemErrorMessage: string;
var
  P: PChar; e:cardinal;
begin
  e:=GetLastError;
  if FormatMessage(Format_Message_Allocate_Buffer OR Format_Message_From_System OR FORMAT_MESSAGE_FROM_HMODULE,
                   pointer(GetModuleHandle('wininet.dll')),
                   e,
                   0,
                   @P,
                   0,
                   nil) <> 0 then
  begin
    Result := inttostr(e)+': '+P;
    LocalFree(Integer(P))
  end
  else
    Result := '';
end;

function GetInetFile
(const fileURL, FileName: String): boolean;
const BufferSize = 1024;
var
  hSession, hURL: HInternet;
  Buffer: array[1..BufferSize] of Byte;
  BufferLen: DWORD;
  f: File;
  sAppName: string;
begin
 Result:=False;
 sAppName := ExtractFileName(Application.ExeName);
 hSession := InternetOpen(PChar(sAppName),
                INTERNET_OPEN_TYPE_PRECONFIG,
               nil, nil, 0);
 if hSession=nil then exit;
 try
  hURL := InternetOpenURL(hSession,
            PChar(fileURL),
            nil,0,0,0);
  if hURL=nil then
  begin
    showmessage(SystemErrorMessage);
    raise exception.Create('hurl is null. cleanup.');
  end;
  try
   AssignFile(f, FileName);
   Rewrite(f,1);
   try
     repeat
       BufferLen:=SizeOf(Buffer);
       InternetReadFile(hURL, @Buffer,
                       SizeOf(Buffer), BufferLen);
      if BufferLen>0 then
        BlockWrite(f, Buffer, BufferLen);                   // -------------Crashes on this line-----------//
      FlashWindow(Application.Handle,True);
     until BufferLen = 0;
     Result:=True;
   except
   end;
   CloseFile(f);
  finally
   InternetCloseHandle(hURL)
  end
 finally
  InternetCloseHandle(hSession)
 end
end;

function getIndyFile(form:TForm; const fileURL, FileName: String): boolean;
var http:TIdHttp;
    s:TFileStream;
    i:integer;
begin
  i:=0;
  while (i<form.ComponentCount) and (form.Components[i].ClassName<>'TIdAntiFreeze') do
    inc(i);
  if i=form.ComponentCount then
    raise exception.Create('You should put an IdAntiFreeze component on your form, otherwise your UI might freeze. Download halted.');
  http:=TIdHTTP.Create(form);
  try
    s:=TFileStream.Create(filename, fmcreate);
    try
      http.Get(fileUrl,s);
      result:=true;
    finally
      s.free;
    end;
  finally
    http.Free;
  end;
end;

procedure TForm1.getadds(Sender: TObject);
var FileOnNet, LocalFileName{ s}: string;
i: integer;
begin
 FileOnNet:='http://www.lfoband.com/adds/adds.txt';
 LocalFileName:=extractfilepath(application.exename)+'adds\adds.txt';
 if {GetInetFile({}getIndyFile(self,FileOnNet,LocalFileName)=True then
   combobox1.Items.LoadFromFile(localfilename)
 else
 begin
   ShowMessage('Error in file download');
   exit;
 end;
 combobox1.itemindex := -1;
 for i:= 0 to combobox1.items.count-1 do
 begin
   combobox1.itemindex := combobox1.itemindex + 1;
   FileOnNet:= combobox1.items[combobox1.itemindex];
   LocalFileName:= extractfilepath(application.exename) +'adds\'+ (extractfilename(combobox1.items[combobox1.itemindex])) ;

   if {GetInetFile({}getIndyFile(self,FileOnNet,LocalFileName)=true then
     showmessage('Sucess !')
   else
     ShowMessage('Error in file download');
 end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  getadds(sender);
end;

end.
